<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBaseTroubleConditionMuteMatch ArrayType
 * @subpackage Arrays
 */
class ArrayOfBaseTroubleConditionMuteMatch extends AbstractStructArrayBase
{
    /**
     * The BaseTroubleConditionMuteMatch
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\BaseTroubleConditionMuteMatch[]
     */
    public $BaseTroubleConditionMuteMatch;
    /**
     * Constructor method for ArrayOfBaseTroubleConditionMuteMatch
     * @uses ArrayOfBaseTroubleConditionMuteMatch::setBaseTroubleConditionMuteMatch()
     * @param \CustomerManagement\StructType\BaseTroubleConditionMuteMatch[] $baseTroubleConditionMuteMatch
     */
    public function __construct(array $baseTroubleConditionMuteMatch = array())
    {
        $this
            ->setBaseTroubleConditionMuteMatch($baseTroubleConditionMuteMatch);
    }
    /**
     * Get BaseTroubleConditionMuteMatch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\BaseTroubleConditionMuteMatch[]|null
     */
    public function getBaseTroubleConditionMuteMatch()
    {
        return isset($this->BaseTroubleConditionMuteMatch) ? $this->BaseTroubleConditionMuteMatch : null;
    }
    /**
     * Set BaseTroubleConditionMuteMatch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\BaseTroubleConditionMuteMatch[] $baseTroubleConditionMuteMatch
     * @return \CustomerManagement\ArrayType\ArrayOfBaseTroubleConditionMuteMatch
     */
    public function setBaseTroubleConditionMuteMatch(array $baseTroubleConditionMuteMatch = array())
    {
        foreach ($baseTroubleConditionMuteMatch as $arrayOfBaseTroubleConditionMuteMatchBaseTroubleConditionMuteMatchItem) {
            // validation for constraint: itemType
            if (!$arrayOfBaseTroubleConditionMuteMatchBaseTroubleConditionMuteMatchItem instanceof \CustomerManagement\StructType\BaseTroubleConditionMuteMatch) {
                throw new \InvalidArgumentException(sprintf('The BaseTroubleConditionMuteMatch property can only contain items of \CustomerManagement\StructType\BaseTroubleConditionMuteMatch, "%s" given', is_object($arrayOfBaseTroubleConditionMuteMatchBaseTroubleConditionMuteMatchItem) ? get_class($arrayOfBaseTroubleConditionMuteMatchBaseTroubleConditionMuteMatchItem) : gettype($arrayOfBaseTroubleConditionMuteMatchBaseTroubleConditionMuteMatchItem)), __LINE__);
            }
        }
        if (is_null($baseTroubleConditionMuteMatch) || (is_array($baseTroubleConditionMuteMatch) && empty($baseTroubleConditionMuteMatch))) {
            unset($this->BaseTroubleConditionMuteMatch);
        } else {
            $this->BaseTroubleConditionMuteMatch = $baseTroubleConditionMuteMatch;
        }
        return $this;
    }
    /**
     * Add item to BaseTroubleConditionMuteMatch value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\BaseTroubleConditionMuteMatch $item
     * @return \CustomerManagement\ArrayType\ArrayOfBaseTroubleConditionMuteMatch
     */
    public function addToBaseTroubleConditionMuteMatch(\CustomerManagement\StructType\BaseTroubleConditionMuteMatch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\BaseTroubleConditionMuteMatch) {
            throw new \InvalidArgumentException(sprintf('The BaseTroubleConditionMuteMatch property can only contain items of \CustomerManagement\StructType\BaseTroubleConditionMuteMatch, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BaseTroubleConditionMuteMatch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\BaseTroubleConditionMuteMatch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\BaseTroubleConditionMuteMatch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\BaseTroubleConditionMuteMatch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\BaseTroubleConditionMuteMatch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\BaseTroubleConditionMuteMatch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BaseTroubleConditionMuteMatch
     */
    public function getAttributeName()
    {
        return 'BaseTroubleConditionMuteMatch';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfBaseTroubleConditionMuteMatch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
